import { BaseTrigger, HttpMethod } from '..';
export declare type FunctionId = string;
export declare type AsyncFunction = (...args: any[]) => Promise<any>;
export interface ApiFunction extends AsyncFunction {
}
export declare type ApiConfig = {
    middleware?: HooksMiddleware[] | any[];
};
export declare type ApiModule = {
    config?: ApiConfig;
    [index: string]: ApiFunction | any;
};
export declare type HooksMiddleware = (next: () => any | Promise<any>) => any;
export declare type HttpRequestOptions = {
    url: string;
    method: HttpMethod;
    data?: {
        args: any[];
    };
    query?: Record<string, string>;
    headers?: Record<string, string>;
};
export declare type RequestRoute<T = any> = {
    trigger: BaseTrigger & T;
    functionId: FunctionId;
    useInputMetadata: boolean;
};
export declare type RequestArgs<Trigger, InputMetaData = void> = InputMetaData extends void ? [...args: any[], route: RequestRoute<Trigger>] : [...args: any[], inputMetadata: InputMetaData, route: RequestRoute<Trigger>];
